<?php

namespace Application\Controller;


use Application\Form\AssocierApplications\AssocierApplicationsForm;
use Application\Form\Categorie\CategorieForm;
use Application\Service\Categorie\CategorieService;
use Psr\Container\ContainerExceptionInterface;
use Psr\Container\ContainerInterface;
use Psr\Container\NotFoundExceptionInterface;

class CategorieControllerFactory {

    /**
     * @throws ContainerExceptionInterface
     * @throws NotFoundExceptionInterface
     */
    public function __invoke(ContainerInterface $container): CategorieController
    {
        /**
         * @var CategorieService $categorieService
         * @var CategorieForm $categorieForm
         * @var AssocierApplicationsForm $associerApplicationsForm
         */
        $categorieService            = $container->get(CategorieService::class);
        $categorieForm               = $container->get('FormElementManager')->get(CategorieForm::class);
        $associerApplicationsForm    = $container->get('FormElementManager')->get(AssocierApplicationsForm::class);


        $controller = new CategorieController();
        $controller->setCategorieService($categorieService);
        $controller->setCategorieForm($categorieForm);
        $controller->setAssocierApplicationsForm($associerApplicationsForm);
        return $controller;
    }
}