<?php

namespace Application\Controller;


use Application\Entity\Db\Categorie;
use Application\Service\Application\ApplicationServiceAwareTrait;
use Application\Service\Categorie\CategorieServiceAwareTrait;
use Laminas\Mvc\Controller\AbstractActionController;
use Laminas\View\Model\ViewModel;
use UnicaenUtilisateur\Service\User\UserServiceAwareTrait;

class IndexController extends AbstractActionController
{
    use UserServiceAwareTrait;
    use ApplicationServiceAwareTrait;
    use CategorieServiceAwareTrait;

    public function indexAction(): ViewModel
    {
        $connectedUser = $this->getUserService()->getConnectedUser();

        $categories = []; $sans = [];
        if ($connectedUser) {
                $categories = $this->getCategorieService()->getCategories('ordre');
                $sans = $this->getApplicationService()->getApplicationsSansCategories();

                if (!empty($sans)) {
                    $categorie = new Categorie();
                    $categorie->setId(0);
                    $categorie->setLibelle("Sans Catégorie");
                    $categorie->setOrdre(1000000);
                    foreach ($sans as $san) $categorie->addApplication($san);
                    $categories[] = $categorie;
                }
        }

        return new ViewModel([
            'connectedUser' => $connectedUser,
            'categories' => $categories,
        ]);
    }

    public function administrationAction(): ViewModel
    {
        return new ViewModel();
    }
}


