<?php

namespace Application\Controller;

use Application\Service\Application\ApplicationService;
use Application\Service\Categorie\CategorieService;
use Psr\Container\ContainerExceptionInterface;
use Psr\Container\ContainerInterface;
use Psr\Container\NotFoundExceptionInterface;
use UnicaenUtilisateur\Service\User\UserService;

class IndexControllerFactory
{
    /**
     * @throws ContainerExceptionInterface
     * @throws NotFoundExceptionInterface
     */
    public function __invoke(ContainerInterface $container): IndexController
    {
        /**
         * @var UserService $connectedService
         * @var ApplicationService $applicationService
         * @var CategorieService $categorieService
         **/
        $userService = $container->get(UserService::class);
        $applicationService = $container->get(ApplicationService::class);
        $categorieService = $container->get(CategorieService::class);

        $controller = new IndexController();
        $controller->setUserService($userService);
        $controller->setApplicationService($applicationService);
        $controller->setCategorieService($categorieService);
        return $controller;
    }
}