<?php

namespace Application\Entity\Db;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use UnicaenUtilisateur\Entity\Db\HistoriqueAwareInterface;
use UnicaenUtilisateur\Entity\Db\HistoriqueAwareTrait;

class Categorie implements HistoriqueAwareInterface {
    use HistoriqueAwareTrait;

    private ?int $id = null;
    private ?string $libelle = null;
    private ?string $description = null;
    private int $ordre = 9999;
    private Collection $applications;

    public function __construct()
    {
        $this->applications = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function setId(?int $id): void
    {
        $this->id = $id;
    }

    public function getLibelle(): ?string
    {
        return $this->libelle;
    }

    public function setLibelle(?string $libelle): void
    {
        $this->libelle = $libelle;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(?string $description): void
    {
        $this->description = $description;
    }

    public function getOrdre(): int
    {
        return $this->ordre;
    }

    public function setOrdre(int $ordre): void
    {
        $this->ordre = $ordre;
    }

    /** @return Application[] */
    public function getApplications(bool $withHisto = false): array
    {
        $applications =  $this->applications->toArray();
        if (!$withHisto) $applications = array_filter($applications, function (Application $application) { return $application->estNonHistorise();});
        usort($applications, function (Application $a, Application $b) { return $a->getLibelle() <=> $b->getLibelle(); });
        return $applications;
    }

    public function clearApplications(): void
    {
        $this->applications->clear();
    }

    /**
     * @param Application $application
     */
    public function addApplication(Application $application): void
    {
        $this->applications->add($application);
    }

}