<?php

namespace Application\Form\Application;

use Application\Entity\Db\Application;
use Laminas\Hydrator\HydratorInterface;

class ApplicationHydrator implements HydratorInterface {

    public function extract(object $object): array
    {
        /** @var Application $object */
        $data = [
            'libelle' => $object->getLibelle(),
            'description' => $object->getDescription(),
            'lien' => $object->getLien(),
            'ordre' => $object->getOrdre(),
            //categories
        ];
        return $data;
    }

    public function hydrate(array $data, object $object): object
    {
        $libelle = (isset($data['libelle']) && trim($data['libelle']) !== '') ? trim($data['libelle']) : null;
        $description = (isset($data['description']) && trim($data['description']) !== '') ? trim($data['description']) : null;
        $lien = (isset($data['lien']) && trim($data['lien']) !== '') ? trim($data['lien']) : null;
        $ordre = $data['ordre'] ?? 9999;

        /** @var Application $object */
        $object->setLibelle($libelle);
        $object->setDescription($description);
        $object->setLien($lien);
        $object->setOrdre($ordre);
        //categories

        return $object;
    }


}