<?php

namespace Application\Form\AssocierApplications;

use Application\Service\Application\ApplicationService;
use Psr\Container\ContainerExceptionInterface;
use Psr\Container\ContainerInterface;
use Psr\Container\NotFoundExceptionInterface;

class AssocierApplicationFormFactory {

    /**
     * @throws ContainerExceptionInterface
     * @throws NotFoundExceptionInterface
     */
    public function __invoke(ContainerInterface $container): AssocierApplicationsForm
    {
        /**
         * @var ApplicationService $applicationService
         * @var AssocierApplicationsHydrator $hydrator
         */
        $applicationService = $container->get(ApplicationService::class);
        $hydrator = $container->get('HydratorManager')->get(AssocierApplicationsHydrator::class);

        $form = new AssocierApplicationsForm();
        $form->setApplicationService($applicationService);
        $form->setHydrator($hydrator);
        return $form;
    }
}