<?php

namespace Application\Form\AssocierApplications;

use Application\Service\Application\ApplicationServiceAwareTrait;
use Laminas\Form\Element\Button;
use Laminas\Form\Element\Select;
use Laminas\Form\Form;
use Laminas\InputFilter\Factory;

class AssocierApplicationsForm extends Form {
    use ApplicationServiceAwareTrait;

    public function init(): void
    {
        //parent
        $this->add([
            'type' => Select::class,
            'name' => 'applications',
            'options' => [
                'label' => "Applications à associer :",
                //'empty_option' => "Aucune application",
                'value_options' => $this->getApplicationService()->getApplicationsAsOptions(),
            ],
            'attributes' => [
                'id' => 'applications',
                'multiple' => true,
                'data-live-search' => "true",

            ],
        ]);
        //submit
        $this->add([
            'type' => Button::class,
            'name' => 'bouton',
            'options' => [
                'label' => '<i class="fas fa-save"></i> Enregistrer',
                'label_options' => [
                    'disable_html_escape' => true,
                ],
            ],
            'attributes' => [
                'type' => 'submit',
                'class' => 'btn btn-primary',
            ],
        ]);

        $this->setInputFilter((new Factory())->createInputFilter([
            'applications' => [
                'name' => 'applications',
                'required' => false,
            ],
        ]));
    }
}