<?php

namespace Application\Form\AssocierApplications;

use Application\Entity\Db\Categorie;
use Application\Service\Application\ApplicationServiceAwareTrait;
use Laminas\Hydrator\HydratorInterface;

class AssocierApplicationsHydrator implements HydratorInterface {
    use ApplicationServiceAwareTrait;

    public function extract(object $object): array
    {
        /** @var Categorie $object */
        $applicationsId = [];
        foreach ($object->getApplications() as $application) $applicationsId[] = $application->getId();

        $data = [
            'applications' => $applicationsId,
        ];
        return $data;
    }

    public function hydrate(array $data, object $object): object
    {
        $applications = [];
        foreach ($data['applications'] as $applicationId) $applications[] = $this->getApplicationService()->getApplication($applicationId);

        /** @var Categorie $object */
        $object->clearApplications();
        foreach ($applications as $application) $object->addApplication($application);
        return $object;
    }


}