<?php

namespace Application\Form\AssocierApplications;

use Application\Service\Application\ApplicationService;
use Psr\Container\ContainerExceptionInterface;
use Psr\Container\ContainerInterface;
use Psr\Container\NotFoundExceptionInterface;

class AssocierApplicationsHydratorFactory {

    /**
     * @throws ContainerExceptionInterface
     * @throws NotFoundExceptionInterface
     */
    public function __invoke(ContainerInterface $container): AssocierApplicationsHydrator
    {
        /**
         * @var ApplicationService $applicationService
         */
        $applicationService = $container->get(ApplicationService::class);

        $hydrator = new AssocierApplicationsHydrator();
        $hydrator->setApplicationService($applicationService);
        return $hydrator;
    }
}