<?php

namespace Application\Form\AssocierCategories;

use Application\Service\Categorie\CategorieServiceAwareTrait;
use Laminas\Form\Element\Button;
use Laminas\Form\Element\Select;
use Laminas\Form\Form;
use Laminas\InputFilter\Factory;

class AssocierCategoriesForm extends Form {
    use CategorieServiceAwareTrait;

    public function init(): void
    {
        //parent
        $this->add([
            'type' => Select::class,
            'name' => 'categories',
            'options' => [
                'label' => "Categories à associer :",
                //'empty_option' => "Aucune categorie",
                'value_options' => $this->getCategorieService()->getCategoriesAsOptions(),
            ],
            'attributes' => [
                'id' => 'categories',
                'multiple' => true,
                'data-live-search' => "true",
            ],
        ]);
        //submit
        $this->add([
            'type' => Button::class,
            'name' => 'bouton',
            'options' => [
                'label' => '<i class="fas fa-save"></i> Enregistrer',
                'label_options' => [
                    'disable_html_escape' => true,
                ],
            ],
            'attributes' => [
                'type' => 'submit',
                'class' => 'btn btn-primary',
            ],
        ]);

        $this->setInputFilter((new Factory())->createInputFilter([
            'categories' => [
                'name' => 'categories',
                'required' => false,
            ],
        ]));
    }
}