<?php

namespace Application\Form\AssocierCategories;

use Application\Service\Categorie\CategorieService;
use Interop\Container\ContainerInterface;
use Psr\Container\ContainerExceptionInterface;
use Psr\Container\NotFoundExceptionInterface;

class AssocierCategoriesFormFactory {

    /**
     * @throws ContainerExceptionInterface
     * @throws NotFoundExceptionInterface
     */
    public function __invoke(ContainerInterface $container): AssocierCategoriesForm
    {
        /**
         * @var CategorieService $categorieService
         * @var AssocierCategoriesHydrator $hydrator
         */
        $categorieService = $container->get(CategorieService::class);
        $hydrator = $container->get('HydratorManager')->get(AssocierCategoriesHydrator::class);

        $form = new AssocierCategoriesForm();
        $form->setCategorieService($categorieService);
        $form->setHydrator($hydrator);
        return $form;
    }
}