<?php

namespace Application\Form\AssocierCategories;

use Application\Entity\Db\Application;
use Application\Service\Categorie\CategorieServiceAwareTrait;
use Laminas\Hydrator\HydratorInterface;

class AssocierCategoriesHydrator implements HydratorInterface {
    use CategorieServiceAwareTrait;

    public function extract(object $object): array
    {
        /** @var Application $object */
        $categoriesId = [];
        foreach ($object->getCategories() as $categorie) $categoriesId[] = $categorie->getId();

        $data = [
            'categories' => $categoriesId,
        ];
        return $data;
    }

    public function hydrate(array $data, object $object): object
    {
        $categories = [];
        foreach ($data['categories'] as $categorieId) $categories[] = $this->getCategorieService()->getCategorie($categorieId);

        $object->clearCategories();
        /** @var Application $object */
        foreach ($categories as $categorie) $object->addCategorie($categorie);
        return $object;
    }


}