<?php

namespace Application\Form\AssocierCategories;

use Application\Service\Categorie\CategorieService;
use Interop\Container\ContainerInterface;
use Psr\Container\ContainerExceptionInterface;
use Psr\Container\NotFoundExceptionInterface;

class AssocierCategoriesHydratorFactory {

    /**
     * @throws ContainerExceptionInterface
     * @throws NotFoundExceptionInterface
     */
    public function __invoke(ContainerInterface $container): AssocierCategoriesHydrator
    {
        /**
         * @var CategorieService $categorieService
         */
        $categorieService = $container->get(CategorieService::class);

        $hydrator = new AssocierCategoriesHydrator();
        $hydrator->setCategorieService($categorieService);
        return $hydrator;
    }
}