<?php

namespace Application\Form\Categorie;

use Application\Entity\Db\Categorie;
use Laminas\Hydrator\HydratorInterface;

class CategorieHydrator implements HydratorInterface {

    public function extract(object $object): array
    {
        /** @var Categorie $object */
        $data = [
            'libelle' => $object->getLibelle(),
            'description' => $object->getDescription(),
            'ordre' => $object->getOrdre(),
            //applications
        ];
        return $data;
    }

    public function hydrate(array $data, object $object): object
    {
        $libelle = (isset($data['libelle']) && trim($data['libelle']) !== '') ? trim($data['libelle']) : null;
        $description = (isset($data['description']) && trim($data['description']) !== '') ? trim($data['description']) : null;
        $ordre = $data['ordre'] ?? 9999;

        /** @var Categorie $object */
        $object->setLibelle($libelle);
        $object->setDescription($description);
        $object->setOrdre($ordre);
        //applications
        return $object;
    }


}